<?php
/*
Plugin Name: Fun with Categories
Plugin URI: http://www.wp-fun.co.uk/fun-with-categories/
Description: Allows posts to be filtered according to two categories
Author: Andrew Rickmann
Version: 1.1
Author URI: http://www.wp-fun.co.uk
Generated At: www.wp-fun.co.uk;
*/ 

/*  Copyright 2007  Andrew Rickmann  (email : PLUGIN AUTHOR EMAIL)

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

/**
* To change the default then change 'categories' at the end of this line. WP2.7+ go to the permalinks settings page.
*/
$dual_cat_base = ( get_option('dual_cat_base')) ? get_option('dual_cat_base') : 'categories';

if (!class_exists('fw_dual_categories')) {
    class fw_dual_categories	{

		
		/**
		* PHP 4 Compatible Constructor
		*/
		function fw_dual_categories(){$this->__construct();}
		
		/**
		* PHP 5 Constructor
		*/		
		function __construct(){

		add_action('template_redirect', array(&$this,'templateredirectintercept'));
		add_action('init', array(&$this,'flush_rewrite_rules'));
		add_action('admin_head', array($this,'add_settings_field'));
		add_action('generate_rewrite_rules', array(&$this,'add_rewrite_rules'));
		add_filter('query_vars', array(&$this,'queryvars') );
		add_filter('posts_where', array(&$this,'posts_where_intercept'));

		}
		
		function add_settings_field(){
			
			//register_setting('permalink','dual_cat_base');
			add_settings_field('dual_cat_base' , 'Dual Categories Base' , array($this,'settings_field_callback') , 'permalink' , 'optional');
		}
		
		function settings_field_callback(){
			
			//sort out the post stuff seeing as I can't get it to work any other way
			if ( isset( $_POST['dual_cat_base'] ) ){
				if ( preg_match( "/^[a-zA-Z0-9-_]*$/" , $_POST['dual_cat_base'] ) ){
					update_option('dual_cat_base' , $_POST['dual_cat_base']);
				}
			}
			
			echo '<input name="dual_cat_base" id="dual_cat_base" type="text" value="'.get_option('dual_cat_base').'" class="regular-text code" />';
		}

	
		/**
		* Adds new variables to the query
		*/
		function queryvars( $qvars ){
		
			$qvars[] = 'dualcategory1';
			$qvars[] = 'dualcategory2';
		  	return $qvars;
		}
		
		/**
		* Flushes the rewrite rules to force it to recrete them, including the new rules.
		*/
		function flush_rewrite_rules() 
		{
		   global $wp_rewrite;
		   $wp_rewrite->flush_rules();
		}
		
		/**
		* Adds the new rewrite rules to the list when the rules are reconstructed.
		*/
		function add_rewrite_rules( $wp_rewrite ) 
		{
			
		global $dual_cat_base;
			
		  $new_rules = array( 
			 $dual_cat_base.'/(.+?)/(.+?)?$' => 'index.php?dualcategory1=' .
			   $wp_rewrite->preg_index(1) . '&dualcategory2=' . $wp_rewrite->preg_index(2) );
		
		  $wp_rewrite->rules = $new_rules + $wp_rewrite->rules;
		}
		
		/**
		* Determine whether to load the template, and, set the is_dual_categories flag
		*/
		function templateredirectintercept(){
		global $wp_query;
		
		$dc1 = $wp_query->get('dualcategory1');
		$dc2 = $wp_query->get('dualcategory2');
		
		if ( $dc1 && $dc2  ) {
			$wp_query->is_dual_categories = true;
			if ( file_exists( TEMPLATEPATH . '/categories.php' ) ) {
				include(TEMPLATEPATH . '/categories.php');
				exit;
			} elseif ( file_exists( TEMPLATEPATH . '/archive.php' ) ) {
				include(TEMPLATEPATH . '/archive.php');
				exit;
			}
		}	
		
		}
		
		/**
		* Alters the query to limit posts to the categories required
		*/
		function posts_where_intercept($wherestring){
			global $wpdb, $wp_query;
			
			$term1 = get_term_by('slug', $wp_query->get('dualcategory1'), 'category');
			$term2 = get_term_by('slug', $wp_query->get('dualcategory2'), 'category');
			
			$dc1 = $term1->term_id;
			$dc2 = $term2->term_id;
		
			if ( $dc1 && $dc2 ) {
			
				$wherestring .= " AND $wpdb->posts.ID IN (SELECT DISTINCT object_id FROM $wpdb->term_relationships WHERE object_id IN (SELECT object_id FROM $wpdb->term_relationships inner join $wpdb->term_taxonomy on $wpdb->term_relationships.term_taxonomy_id = $wpdb->term_taxonomy.term_taxonomy_id WHERE term_id = '".$dc1."') and object_id IN (SELECT object_id FROM $wpdb->term_relationships inner join $wpdb->term_taxonomy on $wpdb->term_relationships.term_taxonomy_id = $wpdb->term_taxonomy.term_taxonomy_id WHERE term_id = '".$dc2."'))	";
			}
			
			return $wherestring;
			
		}



    }
}

//instantiate the class
if (class_exists('fw_dual_categories')) {
	$fw_dual_categories = new fw_dual_categories();
	
	function is_dual_categories(){
		global $wp_query;
		return $wp_query->is_dual_categories;
	}

function dual_cat_titles($categoryrequest = 0, $between = ' and '){
	global $wp_query;
	if ( is_dual_categories() ){
		
		$term1 = get_term_by('slug', $wp_query->get('dualcategory1'), 'category');
		$term2 = get_term_by('slug', $wp_query->get('dualcategory2'), 'category');
	
		switch ( $categoryrequest ) {
		case 0:
			echo ucfirst( $term1->name ).$between.ucfirst( $term2->name );		
			break;
		case 1:
			echo ucfirst ( $term1->name );		
			break;
		case 2:
			echo ucfirst( $term2->name );		
			break;
		}
	}
}
	
}

?>